<template>
  <div class="col-12">
    <!-- DATASET -->
    <div class="row mb-3">
      <div class="col-12">
        <div class="row">
          <div class="col-1 mt-3 pr-0 text-right">
            <span class="arrow text-primary" v-if="!datasetVisible" @click="toggleDataset()">
                <i class="material-icons text-dark">keyboard_arrow_down</i>
              </span>
            <span class="arrow text-primary" v-else @click="toggleDataset()">
                <i class="material-icons text-dark">keyboard_arrow_up</i>
              </span>
          </div>
          <div class="col-10 py-2 text-left">
            <h3 class="heading" @click="toggleDataset()">{{ $t('message.metadata.dataset') }}</h3>
            <div class="description text-muted" @click="toggleDataset()">{{ $t('message.metadata.pageDescriptionDataset') }}</div>
          </div>
          <div class="col-10 offset-1" v-show="datasetVisible">
            <!-- DATASET TITLE -->
            <div class="input-group mb-3">
              <label class="w-100" for="title">
                <span class="align-middle">{{ $t('message.metadata.title') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipTitle')">info</i>
              </label>
              <input class="form-control w-100"
                     id="title"
                     name="Title"
                     type="text"
                     :placeholder="`${$t('message.metadata.enterTitle')}*`"
                     :aria-label="`${$t('message.metadata.enterTitle')}*`"
                     v-model="title"
                     v-validate="{required: true, regex: /^[a-zA-Z0-9 ]*$/ }">
              <br>
              <div class="alert alert-danger w-100" role="alert" v-if="errors.first('Title')">
                {{ errors.first('Title') }}
              </div>
            </div>
            <!-- DATASET DESCRIPTION -->
            <div class="input-group mb-2">
              <label class="w-100" for="description">
                <span class="align-middle">{{ $t('message.metadata.description') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipDescription')">info</i>
              </label>
              <textarea class="form-control w-100"
                        id="description"
                        name="Description"
                        type="text"
                        :placeholder="`${$t('message.metadata.enterDescription')}*`"
                        :aria-label="`${$t('message.metadata.enterDescription')}*`"
                        v-model="description"
                        v-validate="'required'"/>
              <div class="alert alert-danger w-100" role="alert" v-if="errors.first('Description')">
                {{ errors.first('Description') }}
              </div>
            </div>
            <!-- DATASET CATALOGUE -->
            <div class="input-group mb-2">
              <label class="w-100" for="catalogue">
                <span class="align-middle">{{ $t('message.metadata.catalogue') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipCatalogue')">info</i>
              </label>
              <select v-if="catalogueExists"
                      class="custom-select w-100"
                      id="catalogue"
                      name="Catalogue"
                      v-validate="'required'">
                <option :value="replace(this.$route.query.catalog)" selected disabled>{{ replace(this.$route.query.catalog) }}</option>
              </select>
              <select v-else
                      class="custom-select w-100"
                      id="catalogue"
                      name="Catalogue"
                      v-model="catalogue"
                      v-validate="'required'">
                <option value="" selected disabled>{{ $t('message.metadata.chooseCatalogue') }}*</option>
                <option v-for="(catalog, i) in filterDuplicate(catalogues)" :key="`catalog${i}`" :value="replace(catalog)">{{ replace(catalog) }}</option>
              </select>
              <div class="alert alert-danger w-100" role="alert" v-if="errors.first('Catalogue')">
                {{ errors.first('Catalogue') }}
              </div>
            </div>
            <!-- DATASET KEYWORDS -->
            <div class="input-group mb-2 w-100">
              <label class="w-100" for="keywords">
                <span class="align-middle">{{ $t('message.datasetFacets.facets.keywords') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipKeywords')">info</i>
              </label>
              <input class="form-control w-100"
                     id="keywords"
                     name="Keywords"
                     type="text"
                     :placeholder="$t('message.metadata.enterKeywords')"
                     :aria-label="$t('message.metadata.enterKeywords')"
                     v-model="keyword"
                     @keyup.enter="addKeyword()"/>
              <div class="input-group-append position-absolute" style="right:1%;bottom:15%;z-index:9;">
                <span v-for="(keyword, i) in keywords" :key="`keyword${i}`" class="badge badge-pill badge-primary ml-1">
                  {{ keyword }}
                  <span @click="removeKeyword(i)" class="ml-2" style="cursor:pointer;">&times;</span>
                </span>
              </div>
            </div>
            <!-- DATASET CATEGORIES -->
            <label class="w-100" for="categories">
              <span class="align-middle">{{ $t('message.metadata.categories') }}</span>
              <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipCategories')">info</i>
            </label>
            <div class="overflow-auto border p-3" id="categories" style="height:200px">
              <div class="custom-control custom-checkbox" v-for="(category, i) of availableCategories" :key="`category${i}`">
                <input type="checkbox" class="custom-control-input" :checked="categories.includes(category)" :id="`category${i}`" @click="toggleCategory(category)">
                <label class="custom-control-label" :for="`category${i}`">{{ $t(`message.categories.${category}`) }}</label>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- PUBLISHER -->
    <div class="row mb-3">
      <div class="col-12">
        <div class="row">
          <div class="col-1 mt-3 pr-0 text-right">
              <span class="arrow text-primary" v-if="!publisherVisible" @click="togglePublisher()">
                <i class="material-icons text-dark">keyboard_arrow_down</i>
              </span>
            <span class="arrow text-primary" v-else @click="togglePublisher()">
                <i class="material-icons text-dark">keyboard_arrow_up</i>
              </span>
          </div>
          <div class="col-10 py-2 text-left">
            <h3 class="heading" @click="togglePublisher()">{{ $t('message.metadata.publisher') }}</h3>
            <div class="description text-muted" @click="togglePublisher()">{{ $t('message.metadata.pageDescriptionPublisher') }}</div>
          </div>
          <div class="col-10 offset-1" v-if="publisherVisible">
            <!-- PUBLISHER TYPE -->
            <div class="input-group mb-2">
              <label class="w-100" for="publisherType">
                <span class="align-middle">{{ $t('message.metadata.type') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipPublisherType')">info</i>
              </label>
              <select class="custom-select w-100"
                      id="publisherType"
                      name="Publisher Type"
                      v-model="publisher.type">
                <option value="" selected disabled>{{ $t('message.metadata.chooseType') }}</option>
                <option>{{ $t('message.datasetDetails.upload.person') }}</option>
                <option>{{ $t('message.datasetDetails.upload.organisation') }}</option>
              </select>
            </div>
            <!-- PUBLISHER NAME -->
            <div class="input-group mb-2">
              <label class="w-100" for="publisherName">
                <span class="align-middle">{{ $t('message.metadata.name') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipPublisherName')">info</i>
              </label>
              <input class="form-control w-100"
                     id="publisherName"
                     name="Publisher Name"
                     type="text"
                     :placeholder="$t('message.metadata.enterName')"
                     :aria-label="$t('message.metadata.enterName')"
                     v-model="publisher.name">
            </div>
            <!-- PUBLISHER HOMEPAGE -->
            <div class="input-group mb-2">
              <label class="w-100" for="publisherHomepage">
                <span class="align-middle">{{ $t('message.metadata.homepage') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipPublisherHomepage')">info</i>
              </label>
              <input class="form-control w-100"
                     id="publisherHomepage"
                     name="Publisher Homepage"
                     type="text"
                     :placeholder="$t('message.metadata.enterHomepage')"
                     :aria-label="$t('message.metadata.enterHomepage')"
                     v-model="publisher.homepage"
                     v-validate="{url: {require_protocol: true }}">
              <div class="alert alert-danger w-100" role="alert" v-if="errors.first('Publisher Homepage')">
                {{ errors.first('Publisher Homepage') }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- CONTACT POINT -->
    <div class="row mb-3">
      <div class="col-12">
        <div class="row">
          <div class="col-1 mt-3 pr-0 text-right">
              <span class="arrow text-primary" v-if="!contactPointVisible" @click="toggleContactPoint()">
                <i class="material-icons text-dark">keyboard_arrow_down</i>
              </span>
            <span class="arrow text-primary" v-else @click="toggleContactPoint()">
                <i class="material-icons text-dark">keyboard_arrow_up</i>
              </span>
          </div>
          <div class="col-10 py-2 text-left">
            <h3 class="heading" @click="toggleContactPoint()">{{ $t('message.metadata.contactPoints') }}</h3>
            <div class="description text-muted" @click="toggleContactPoint()">{{ $t('message.metadata.pageDescriptionContactPoint') }}</div>
          </div>
          <div class="col-10 offset-1" v-if="contactPointVisible">
            <!-- CONTACT POINT TYPE -->
            <div class="input-group mb-2">
              <label class="w-100" for="contactType">
                <span class="align-middle">{{ $t('message.metadata.type') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipContactType')">info</i>
              </label>
              <select class="custom-select w-100"
                      id="contactType"
                      name="Contact Type"
                      v-model="contact.type">
                <option value="" selected disabled>{{ $t('message.metadata.chooseType') }}</option>
                <option>{{ $t('message.datasetDetails.upload.individual') }}</option>
                <option>{{ $t('message.datasetDetails.upload.organisation') }}</option>
              </select>
            </div>
            <!-- CONTACT POINT NAME -->
            <div class="input-group mb-2">
              <label class="w-100" for="contactName">
                <span class="align-middle">{{ $t('message.metadata.name') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipContactName')">info</i>
              </label>
              <input class="form-control w-100"
                     id="contactName"
                     name="Contact Name"
                     type="text"
                     :placeholder="$t('message.metadata.enterName')"
                     :aria-label="$t('message.metadata.enterName')"
                     v-model="contact.name">
            </div>
            <!-- CONTACT POINT EMAIL -->
            <div class="input-group mb-2">
              <label class="w-100" for="contactEmail">
                <span class="align-middle">{{ $t('message.metadata.email') }}</span>
                <i class="material-icons small-icon text-dark align-middle" data-toggle="tooltip" data-placement="bottom" :title="$t('message.metadata.tooltipContactEmail')">info</i>
              </label>
              <input class="form-control w-100"
                     id="contactEmail"
                     name="Contact Email"
                     type="email"
                     :placeholder="$t('message.metadata.enterEmail')"
                     :aria-label="$t('message.metadata.enterEmail')"
                     v-model="contact.email"
                     v-validate="'email'">
              <div class="alert alert-danger w-100" role="alert" v-if="errors.first('Contact Email')">
                {{ errors.first('Contact Email') }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import $ from 'jquery';
  import { mapGetters, mapActions } from 'vuex';
  import { decode } from '../../utils/jwt';
  import { normalize, getTranslationFor } from '../../utils/helpers';

  export default {
    name: 'DatasetDetails',
    components: {},
    data() {
      return {
        editingDataset: false,
        datasetVisible: true,
        contactPointVisible: true,
        publisherVisible: true,
        title: '',
        description: '',
        catalogues: [],
        catalogue: '',
        keyword: '',
        keywords: [],
        availableCategories: [
          'tran',
          'heal',
          'gove',
          'envi',
          'intr',
          'agri',
          'soci',
          'econ',
          'educ',
          'ener',
          'tech',
          'regi',
          'just',
        ],
        categories: [],
        publisher: {
          type: '',
          name: '',
          homepage: '',
        },
        contact: {
          type: '',
          name: '',
          email: '',
        },
      };
    },
    computed: {
      ...mapGetters('upload', [
        'getValidate',
      ]),
      query() {
        if (this.catalogueExists) return { catalog: this.$route.query.catalog, locale: this.$route.query.locale };
        return { locale: this.$route.query.locale };
      },
      catalogueExists() {
        if (typeof this.$route.query.catalog === 'string') this.catalogue = this.$route.query.catalog;
        return typeof this.$route.query.catalog === 'string';
      },
    },
    methods: {
      ...mapActions('upload', [
        'setStep',
        'setValidate',
        'addDatasetDetails',
      ]),
      decode,
      normalize,
      getTranslationFor,
      toggleDataset() {
        this.datasetVisible = !this.datasetVisible;
        if (this.datasetVisible) {
          this.$nextTick(() => {
            // Activate Bootstrap Tooltips
            $('[data-toggle="tooltip"]').tooltip({
              container: 'body',
            });
          });
        }
      },
      togglePublisher() {
        this.publisherVisible = !this.publisherVisible;
        if (this.publisherVisible) {
          this.$nextTick(() => {
            // Activate Bootstrap Tooltips
            $('[data-toggle="tooltip"]').tooltip({
              container: 'body',
            });
          });
        }
      },
      toggleContactPoint() {
        this.contactPointVisible = !this.contactPointVisible;
        if (this.contactPointVisible) {
          this.$nextTick(() => {
            // Activate Bootstrap Tooltips
            $('[data-toggle="tooltip"]').tooltip({
              container: 'body',
            });
          });
        }
      },
      toggleCategory(category) {
        if (this.categories.includes(category)) this.categories.splice(this.categories.indexOf(category), 1);
        else this.categories.push(category);
      },
      addKeyword() {
        if (!this.keyword) return;
        this.keywords.push(this.keyword);
        this.keyword = '';
      },
      removeKeyword(index) {
        this.keywords.splice(index, 1);
      },
      filterDuplicate(obj) {
        return [...new Set(obj)];
      },
      replace(str) {
        return str.replace(`${this.$env.api.catalogBaseUrl}id/catalogue/`, '');
      },
      // Get all catalogs that have the update permission
      getCatalogs(jwtObj) {
        jwtObj.authorization.permissions.forEach((permission) => {
          permission.scopes.forEach((scope) => {
            if (scope === 'update') {
              this.catalogues.push(permission.rsname);
            }
          });
        });
      },
      // Read Data from window.localStorage
      loadDataFromLocalStorage() {
        // Read dataset attributes from local storage
        if (localStorage.getItem('catalogue')) {
          this.catalogue = JSON.parse(localStorage.getItem('catalogue'));
        }
        if (localStorage.getItem('title')) {
          this.title = JSON.parse(localStorage.getItem('title'));
        }
        if (localStorage.getItem('description')) {
          this.description = JSON.parse(localStorage.getItem('description'));
        }
        if (localStorage.getItem('keywords')) {
          this.keywords = JSON.parse(localStorage.getItem('keywords'));
        }
        if (localStorage.getItem('categories')) {
          this.categories = JSON.parse(localStorage.getItem('categories'));
        }
        if (localStorage.getItem('contact')) {
          this.contact = JSON.parse(localStorage.getItem('contact'));
        }
        if (localStorage.getItem('publisher')) {
          this.publisher = JSON.parse(localStorage.getItem('publisher'));
        }
      },
      // Read Data from $route.params when EDITING
      async loadDataFromParams() {
        // Set editingDataset
        this.editingDataset = this.$route.params.title !== undefined && this.$route.params.description !== undefined && this.$route.params.catalog !== undefined;

        const rtpToken = await this.$keycloak.getRtpToken();
        const decoded = decode(rtpToken.data.access_token);
        this.getCatalogs(decoded);

        if (this.$route.params.title) {
          this.title = typeof this.$route.params.title === 'object'
            ? getTranslationFor(this.$route.params.title, this.$route.query.locale, [])
            : this.$route.params.title;
        }
        if (this.$route.params.description) {
          this.description = typeof this.$route.params.description === 'object'
            ? getTranslationFor(this.$route.params.description, this.$route.query.locale, [])
            : this.$route.params.description;
        }
        if (this.$route.params.keywords) {
          this.$route.params.keywords.forEach((keyword) => {
            this.keywords.push(keyword.title);
          });
        }
        if (this.$route.params.catalog) {
          this.catalogue = this.$route.params.catalog;
        }
        if (this.$route.params.category) {
          this.$route.params.category.forEach((value) => {
            this.categories.push(value.title);
          });
        }
        // TODO: Handle multiple contact points (requires inserting more input fields)
        if (typeof this.$route.params.contact_point !== 'undefined' && this.$route.params.contact_point.length > 0) {
          this.contact.type = this.$route.params.contact_point[0].type;
          this.contact.name = this.$route.params.contact_point[0].name;
          this.contact.email = (this.$route.params.contact_point[0].email).replace('mailto:', '');
        }
        // TODO: Handle unknown publisher types
        if (this.$route.params.publisher) {
          this.publisher.type = (this.$route.params.publisher.type === '' || typeof this.$route.params.publisher.type === 'undefined') ? '' : this.$route.params.publisher.type;
          this.publisher.name = (this.$route.params.publisher.name === '' || typeof this.$route.params.publisher.name === 'undefined') ? '' : this.$route.params.publisher.name;
          this.publisher.homepage = (this.$route.params.publisher.resource === '' || typeof this.$route.params.publisher.resource === 'undefined') ? '' : this.$route.params.publisher.resource;
          // Hack fix for linked_data not mapped with search API
          if (this.$route.params.publisher.email) {
            this.publisher.homepage = (this.$route.params.publisher.email === '' || typeof this.$route.params.publisher.email === 'undefined') ? '' : this.$route.params.publisher.email;
          }
        }
      },
      // Validate Dataset Details
      next() {
        this.$Progress.start();
        this.$validator.validate().then((valid) => {
          if (valid) {
            // Add Dataset Details
            const dataset = {
              title: this.title.replace(/  +/g, ' '),
              description: this.description,
              keywords: this.keywords.length === 0 ? null : this.keywords,
              category: this.categories,
              contact: this.contact,
              publisher: this.publisher,
              catalogue: this.catalogue,
            };
            this.addDatasetDetails(dataset);
            this.$Progress.finish();
            // Navigate to Step 2
            this.setStep(2);
            this.$router.push({ name: 'UploadPageDistributions', query: this.query, params: this.$route.params });
          } else {
            // Open toggled content to show all errors
            this.$Progress.fail();
            this.datasetVisible = true;
            this.contactPointVisible = true;
            this.publisherVisible = true;
          }
        });
      },
    },
    watch: {
      getValidate: {
        handler(validate) {
          if (validate) {
            // Call next function
            this.next();
            // Reset Validate State
            this.setValidate(false);
          }
        },
      },
      // Watch on all dataset attributes to store them into local storage on change
      catalogue: {
        handler(newCatalogue) {
          localStorage.setItem('catalogue', JSON.stringify(newCatalogue));
        },
        deep: true,
      },
      title: {
        handler(newTitle) {
          localStorage.setItem('title', JSON.stringify(newTitle));
          // Set new ID
          let newID = newTitle.replace(/\s+/g, '-').toLowerCase();
          newID = this.normalize(newID);
          localStorage.setItem('ID', JSON.stringify(newID));
        },
        deep: true,
      },
      description: {
        handler(newDescription) {
          localStorage.setItem('description', JSON.stringify(newDescription));
        },
        deep: true,
      },
      keywords: {
        handler(newKeywords) {
          localStorage.setItem('keywords', JSON.stringify(newKeywords));
        },
        deep: true,
      },
      categories: {
        handler(newCategories) {
          localStorage.setItem('categories', JSON.stringify(newCategories));
        },
        deep: true,
      },
      contact: {
        handler(newContact) {
          localStorage.setItem('contact', JSON.stringify(newContact));
        },
        deep: true,
      },
      publisher: {
        handler(newPublisher) {
          localStorage.setItem('publisher', JSON.stringify(newPublisher));
        },
        deep: true,
      },
    },
    created() {
      // Load Data from Route Params when EDITing
      this.loadDataFromParams();
      this.$nextTick(() => {
        // Activate Bootstrap Tooltips
        $('[data-toggle="tooltip"]').tooltip({
          container: 'body',
        });
      });
    },
    mounted() {
      // Load Data from Local Storage if not editing
      if (!this.editingDataset) this.loadDataFromLocalStorage();
    },
  };
</script>

<style lang="scss" scoped>
  label {
    font-weight: bold;

    &.custom-control-label {
      font-weight: normal;
    }
  }

  .heading {
    display: inline-block;
  }

  .heading, .description, .arrow {
    cursor: pointer !important;
  }

  .custom-select {
    -webkit-appearance: none !important;
  }

  .input-group{
    align-items: center !important;
  }

  /*** MATERIAL ICONS ***/
  .material-icons.small-icon {
    font-size: 21px;
  }
</style>
